'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clear = exports.receiveAsyncErrors = exports.noAsyncErrors = exports.requestAsyncValidation = exports.submitFailed = exports.submitSuccessful = exports.submit = exports.touch = exports.blur = exports.focus = exports.change = exports.detachFromForm = exports.attachToForm = exports.unregisterForm = exports.registerForm = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _reduxActions = require('redux-actions');

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var registerForm = exports.registerForm = (0, _reduxActions.createAction)(_constants.REGISTER_FORM);
var unregisterForm = exports.unregisterForm = (0, _reduxActions.createAction)(_constants.UNREGISTER_FORM);

var attachToForm = exports.attachToForm = (0, _reduxActions.createAction)(_constants.ATTACH_TO_FORM);
var detachFromForm = exports.detachFromForm = (0, _reduxActions.createAction)(_constants.DETACH_FROM_FORM);

var change = exports.change = (0, _reduxActions.createAction)(_constants.CHANGE);

var focus = exports.focus = (0, _reduxActions.createAction)(_constants.FOCUS);
var blur = exports.blur = (0, _reduxActions.createAction)(_constants.BLUR);
var touch = exports.touch = (0, _reduxActions.createAction)(_constants.TOUCH, function (_ref) {
  var field = _ref.field;
  var rest = (0, _objectWithoutProperties3.default)(_ref, ['field']);

  // Can accept single field to touch
  if (field) return (0, _extends3.default)({ fields: [field] }, rest);
  return (0, _extends3.default)({}, rest);
});

var submit = exports.submit = (0, _reduxActions.createAction)(_constants.SUBMIT_REQUEST);
var submitSuccessful = exports.submitSuccessful = (0, _reduxActions.createAction)(_constants.SUBMIT_SUCCESS);
var submitFailed = exports.submitFailed = (0, _reduxActions.createAction)(_constants.SUBMIT_FAILURE);

var requestAsyncValidation = exports.requestAsyncValidation = (0, _reduxActions.createAction)(_constants.VALIDATION_REQUEST);
var noAsyncErrors = exports.noAsyncErrors = (0, _reduxActions.createAction)(_constants.VALIDATION_NO_ERRORS);
var receiveAsyncErrors = exports.receiveAsyncErrors = (0, _reduxActions.createAction)(_constants.VALIDATION_ERRORS);

var clear = exports.clear = (0, _reduxActions.createAction)(_constants.CLEAR_FORM);