'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createFormWrapper = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _lodash = require('lodash');

var _actions = require('./actions');

var _selectors = require('./selectors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createFormWrapper = function createFormWrapper(_ref) {
  var id = _ref.id;
  return function (FormComponent) {
    var _class, _temp;

    return _temp = _class = function (_React$Component) {
      (0, _inherits3.default)(FormWrapper, _React$Component);

      function FormWrapper(props) {
        (0, _classCallCheck3.default)(this, FormWrapper);

        var _this = (0, _possibleConstructorReturn3.default)(this, (FormWrapper.__proto__ || (0, _getPrototypeOf2.default)(FormWrapper)).call(this, props));

        _this.handleSubmit = function (submitFunction) {
          var callbacks = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
          return function (e) {
            e.preventDefault();
            var _this$props = _this.props;
            var fields = _this$props.fields;
            var isValid = _this$props.isValid;
            var dispatch = _this$props.dispatch;
            var values = _this$props.values;

            var _callbacks = (0, _slicedToArray3.default)(callbacks, 2);

            var onSubmitSuccess = _callbacks[0];
            var onSubmitFailure = _callbacks[1];

            var fieldNames = fields.map(function (f) {
              return f.get('name');
            }).toList();
            // Touch all the fields
            _this.props.touch({ id: id, fields: fieldNames });

            if (isValid) {
              dispatch(submitFunction(id, { values: values }, { onSubmitSuccess: onSubmitSuccess, onSubmitFailure: onSubmitFailure }));
            }
          };
        };

        _this.attach = _this.attach.bind(_this);
        _this.detach = _this.detach.bind(_this);
        _this.change = _this.change.bind(_this);
        _this.clear = _this.clear.bind(_this);
        return _this;
      }

      (0, _createClass3.default)(FormWrapper, [{
        key: 'getChildContext',
        value: function getChildContext() {
          return { form: this };
        }
      }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
          this.props.registerForm(id);
        }
      }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps) {
          return this.props.values !== nextProps.values || this.props.errors !== nextProps.errors || this.props.isValid !== nextProps.isValid || this.props.isSubmitting !== nextProps.isSubmitting || this.props.fields !== nextProps.fields;
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.props.unregisterForm(id);
        }
      }, {
        key: 'attach',
        value: function attach(payload) {
          this.props.attachToForm((0, _extends3.default)({}, payload, { id: id }));
        }
      }, {
        key: 'detach',
        value: function detach(payload) {
          this.props.detachFromForm((0, _extends3.default)({}, payload, { id: id }));
        }
      }, {
        key: 'change',
        value: function change(payload) {
          this.props.change((0, _extends3.default)({}, payload, { id: id }));
        }
        /** Methods available to the form */

      }, {
        key: 'clear',
        value: function clear(fields) {
          this.props.clear({ id: id, fields: fields });
        }
      }, {
        key: 'render',
        value: function render() {
          // We don't want to give the form access to the dispatch methods specific
          // to Forms, but we still want to pass down any other properties, e.g.
          // forms are often connected components, so they receive props from the
          // state. We need to make the process commutative so that the component
          // can be wrapped `connect(form(Component))` as well as with
          // form(connect(Component))
          var propsToPass = (0, _lodash.omit)(this.props, ['registerForm', 'unregisterForm', 'attachToForm', 'detachFromForm', 'change', 'touch', 'clear']);
          return _react2.default.Children.only(_react2.default.createElement(FormComponent, (0, _extends3.default)({
            handleSubmit: this.handleSubmit,
            clear: this.clear
          }, propsToPass)));
        }
      }, {
        key: 'id',
        get: function get() {
          return id;
        }
      }]);
      return FormWrapper;
    }(_react2.default.Component), _class.displayName = 'Form(' + FormComponent.displayName + ')', _class.propTypes = {
      // Connected values
      isSubmitting: _react2.default.PropTypes.bool.isRequired,
      values: _react2.default.PropTypes.object.isRequired,
      errors: _react2.default.PropTypes.object.isRequired,
      isValid: _react2.default.PropTypes.bool.isRequired,
      fields: _react2.default.PropTypes.object.isRequired,
      // Dispatch methods
      registerForm: _react2.default.PropTypes.func.isRequired,
      unregisterForm: _react2.default.PropTypes.func.isRequired,
      attachToForm: _react2.default.PropTypes.func.isRequired,
      detachFromForm: _react2.default.PropTypes.func.isRequired,
      change: _react2.default.PropTypes.func.isRequired,
      touch: _react2.default.PropTypes.func.isRequired,
      clear: _react2.default.PropTypes.func.isRequired,
      dispatch: _react2.default.PropTypes.func.isRequired
    }, _class.childContextTypes = {
      form: _react2.default.PropTypes.object
    }, _temp;
  };
};
exports.createFormWrapper = createFormWrapper;


var createForm = function createForm(options) {
  return function (FormComponent) {
    var WrappedComponent = createFormWrapper(options)(FormComponent);

    var id = options.id;


    var mapStateToProps = function mapStateToProps(state) {
      return {
        isSubmitting: (0, _selectors.getFormIsSubmitting)(id)(state),
        values: (0, _selectors.getFormValues)(id)(state),
        errors: (0, _selectors.getFormErrors)(id)(state),
        isValid: (0, _selectors.getFormIsValid)(id)(state),
        fields: (0, _selectors.getFormFields)(id)(state)
      };
    };
    var mapDispatchToProps = function mapDispatchToProps(dispatch) {
      return {
        registerForm: (0, _redux.bindActionCreators)(_actions.registerForm, dispatch),
        unregisterForm: (0, _redux.bindActionCreators)(_actions.unregisterForm, dispatch),
        attachToForm: (0, _redux.bindActionCreators)(_actions.attachToForm, dispatch),
        detachFromForm: (0, _redux.bindActionCreators)(_actions.detachFromForm, dispatch),
        change: (0, _redux.bindActionCreators)(_actions.change, dispatch),
        touch: (0, _redux.bindActionCreators)(_actions.touch, dispatch),
        submitSuccessful: (0, _redux.bindActionCreators)(_actions.submitSuccessful, dispatch),
        submitFailed: (0, _redux.bindActionCreators)(_actions.submitFailed, dispatch),
        clear: (0, _redux.bindActionCreators)(_actions.clear, dispatch),
        dispatch: dispatch
      };
    };
    return (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(WrappedComponent);
  };
};

exports.default = createForm;