'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.REQUIRE_DATA = exports.sameAs = exports.email = exports.alphaDash = exports.alpha = exports.length = exports.required = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _validator = require('validator');

var _validator2 = _interopRequireDefault(_validator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Simple validations
 */

var required = exports.required = function required(str) {
  return _validator2.default.isLength(_validator2.default.trim(str), 1);
};
var length = exports.length = function length(str, _ref) {
  var _ref2 = (0, _slicedToArray3.default)(_ref, 2);

  var min = _ref2[0];
  var max = _ref2[1];
  return _validator2.default.isLength(str, { min: min, max: max });
};
var alpha = exports.alpha = function alpha(str) {
  return _validator2.default.matches(str, /^[ A-Za-z\u010C\u010D\u0160\u0161\u017D\u017E]*$/);
};
var alphaDash = exports.alphaDash = function alphaDash(str) {
  return _validator2.default.matches(str, /^[ \-A-Za-z\u010C\u010D\u0160\u0161\u017D\u017E]*$/);
};
var email = exports.email = function email(str) {
  return str === '' || _validator2.default.isEmail(str);
};

/**
 * Validations with other fields
 */

var sameAs = exports.sameAs = function sameAs(str, _ref3, formData) {
  var _ref4 = (0, _slicedToArray3.default)(_ref3, 1);

  var same = _ref4[0];
  return str === formData[same];
};

var REQUIRE_DATA = exports.REQUIRE_DATA = {
  sameAs: sameAs
};